#!/usr/bin/perl

($in, $out) = @ARGV;

%table2 = (     #from ornstein 1978 table IX method 7
        'AA' => 5.37,
        'AT' => 6.57,
        'TA' => 3.82,
        'TT' => 5.37,
        'AG' => 6.78,
        'AC' => 10.51,
        'TG' => 6.57,
        'TC' => 9.81,
        'GA' => 9.81,
        'GT' => 10.51,
        'CA' => 6.57,
        'CT' => 6.78,
        'GG' => 8.26,
        'GC' => 14.59,
        'CG' => 9.69,
        'CC' => 8.26);


open IN, "$in";
open OUT, ">$out";
while ($line = <IN>) {
	chomp $line;
	if ($. == 1) {
		print OUT $line."\n";
		next;
	}
	@d = split /\s+/, $line;
	$kmer = $d[0];
	$enth = 0;
	foreach $i (0..(length $kmer)-2) {
		$dimer = substr $kmer, $i, 2;
		$val = $table2{$dimer};
#		print "$val\n";
		$enth += $val;
	}
	$d[1] = $enth;
	$line = join "\t", @d;
	print OUT $line."\n";
}