#!/usr/bin/env Rscript

##It is not recommended to use this script without lambdaCalc.pl. 

cargs <- commandArgs(T)
outfile = cargs[1]
lo = as.numeric(cargs[2])
hi = as.numeric(cargs[3])
clip = as.numeric(cargs[4])

p <- paste(outfile,".lengthStat.pdf",sep="")
outfile <- paste(outfile,".lambdaStat.txt",sep="")
pdf(file=p)
#d <- read.table("stdin")[,1]
#t <- table(factor(d,levels=min(d):max(d)))
d <- read.table("stdin")
x <- min(d[,1]):max(d[,1])
y <- as.numeric(d[,2])
y <- y/sum(y)
if (clip > 0) {
	for (i in 1:length(y)) {
		if (y[i]>clip) {
			y[i] = 0;
		}
	}
}

#plot(x,y,cex=.8)
xleg <- max(x)
yleg <- max(y)
for (f in 1:50) {
i <- length(y)
j <- i-1
if (y[j]<y[i]) {
y <- y[1:j]
x <- x[1:j]
}
}
plot(x,y,cex=.8,ylab="Proportion of Reads",xlab="Read Length")
m <- c()
minlen <- 20
for (i in 1:(length(x)-minlen)) {
	for (l in minlen:(length(x)-i)) {
		x1 <- x[i:(i+l)]
		y1 <- y[i:(i+l)]
		set <- try(b <- nls(y1 ~ N*exp(-k*x1), start=list(k=.05, N=.1)), silent=TRUE)
		if (class(set)=="nls") {
			k <- summary(b)$coefficients[1]
			N <- summary(b)$coefficients[2]
			p <- summary(b)$coefficients[7]
			h <- c(x[i],l,k,N,p)
			m <- as.matrix(rbind(m,h))
		}
	}
}

maxP <- quantile(m[,5],.05)
m <- m[m[,3]>0,]
m1 <- m[m[,5]<maxP,]
m1 <- m1[order(m1[,5]),]
for (i in 1:length(m1[,1])) {
	N <- m1[i,4]
	k <- m1[i,3]
	lines(x,N*exp(-k*x),col=rgb(0,0,1,alpha=0.03))
}
	
i <- as.numeric(m1[1,1])
len <- as.numeric(m1[1,2])
k <- as.numeric(m1[1,3])
N <- as.numeric(m1[1,4])
i <- (i+1)-x[1]
x1 <- x[i:(i+len)]
y1 <- y[i:(i+len)]
min5 <- (min(m1[,1])+1)-x[1]
max5 <- (max(m1[,1]+m1[,2]))-x[1]
x5 <- x[min5:max5]
y5 <- y[min5:max5]
points(x5,y5,pch=19,col="gray80")
points(x1,y1,pch=19)
points(x,N*exp(-k*x),pch=18,col="red")
b <- nls(y1 ~ N*exp(-k*x1), start=list(k=.05, N=.1))
conf <- confint(b)
mink <- min(m1[,3])
maxk <- max(m1[,3])
minN <- min(m1[,4])
maxN <- max(m1[,4])
dump <- c(conf[1,1],k,conf[1,2],conf[2,1],N,conf[2,2],mink, maxk, minN, maxN, i+x[1], len+x[i], xleg-x[length(x)], x[1], xleg)
if (lo > 0 | hi > 0) {
	lo1 <- lo-(x[1]-1)
	hi1 <- hi-(x[1]-1)
	x1 <- x[lo1:hi1]
	y1 <- y[lo1:hi1]
	set <- try(b <- nls(y1 ~ N*exp(-k*x1), start=list(k=.05, N=.1)), silent=TRUE)
	if (class(set)=="nls") {
		k <- summary(b)$coefficients[1]
		N <- summary(b)$coefficients[2]
		dump[2] = k;
		dump[5] = N;
		lines(x,N*exp(-k*x),col=rgb(1,0,0),lwd=2)
	}
}
dump <- as.matrix(dump)
row.names(dump) <- c("k-2.5%","k-50%","k-97.5%","N-2.5%","N-50%","N-97.5%","min-k", "max-k", "min-N", "max-N", "start", "end", "clipped-top", "low", "high")
write.table(dump, file=outfile, col.names=F, quote=F)
dev.off()
