#!/usr/bin/perl

($ref, $targ, $out) = @ARGV;

unless (@ARGV==3) {
	print "\nUsage: perl $0 ref.kmerCount.txt sample.kmerCount.txt outfile\n";
	die "See \"ExpedientCode.txt\" and \"scripts/\" in Kistler et al 2017 bioRxiv Supp Data S2 upload for how to produce input files\n\n";
}

%table2 = (     #from ornstein 1978 table IX method 7
        'AA' => 5.37,
        'AT' => 6.57,
        'TA' => 3.82,
        'TT' => 5.37,
        'AG' => 6.78,
        'AC' => 10.51,
        'TG' => 6.57,
        'TC' => 9.81,
        'GA' => 9.81,
        'GT' => 10.51,
        'CA' => 6.57,
        'CT' => 6.78,
        'GG' => 8.26,
        'GC' => 14.59,
        'CG' => 9.69,
        'CC' => 8.26);

open IN, $ref;
while ($line = <IN>) {
	chomp $line;
	($kmer, $freq) = split /\s+/, $line;
	foreach $pos (0..(length $kmer)-2) {
		$dimer = substr $kmer, $pos, 2;
		$master{$kmer} += $table2{$dimer};
	}
	$refhold{$kmer} = $freq;
}
close IN;
open IN, $targ;
while ($line = <IN>) {
	chomp $line;
	($kmer, $freq) = split /\s+/, $line;
	$targ{$kmer} = $freq;
}
close IN;

open OUT, ">$out";
print OUT "kmer\tenthalpy\tentropy\tGC\tobs\trefFreq\tsampFreq\n";
foreach $kmer (sort keys %refhold) {
	$targ{$kmer} = 0 unless (exists ($targ{$kmer}));
	$gc = $kmer;
	$gc =~ s/[AT]//g;
	$gc = (length $gc)/(length $kmer);
	$dif = $targ{$kmer}/$refhold{$kmer};
	$ent = &entropy($kmer);
	print OUT $kmer."\t".$master{$kmer}."\t".$ent."\t".$gc."\t".$dif."\t".$refhold{$kmer}."\t".$targ{$kmer}."\n";
}


sub entropy {
        $flankseq = $_[0];
        foreach $i ("A", "C", "G", "T") {
                $calc{$i} = 0;
        }
        foreach $i (split("", $flankseq)) {
                $calc{$i}++ if ($i =~ /[ACGT]/);
        }
        $total = 0;
        foreach $i (values %calc) {
                $total += $i;
        }
        foreach $i (keys %calc) {
                $calc{$i} = $calc{$i}*(1/$total);
        }
        $entropy = 0;
        foreach $i (keys %calc) {
                $entropy += -1*$calc{$i}*(log($calc{$i})/log(2)) unless ($calc{$i} == 0);
        }
        return $entropy;
}
